
DEFINE TEMP-TABLE tt-aa-edi-system LIKE aa-edi-system.

DEF VAR cSchedulerID  AS CHAR NO-UNDO.

DEFINE BUFFER b-aa-edi-schedule FOR aa-edi-schedule.

DO TRANSACTION ON ERROR UNDO, LEAVE : 

  /*- de oude scheduler codes uit de vorige release overnemen -*/
  FILE-INFO:FILE-NAME = SESSION:TEMP-DIRECTORY + "sp-schedulers.txt".
  IF FILE-INFO:FULL-PATHNAME <> ?
  THEN DO:
    INPUT FROM VALUE(FILE-INFO:FULL-PATHNAME).
    REPEAT:
      CREATE tt-aa-edi-system.
      IMPORT DELIMITER ";" tt-aa-edi-system.

      FIND aa-edi-scheduler WHERE
           aa-edi-scheduler.schedulerid_code = tt-aa-edi-system.system_code
           NO-LOCK NO-ERROR.
      IF NOT AVAILABLE aa-edi-scheduler
      THEN DO:
        CREATE aa-edi-scheduler.
        ASSIGN aa-edi-scheduler.schedulerid_code = tt-aa-edi-system.system_code
               aa-edi-scheduler.des = tt-aa-edi-system.des
               .
      END. /* IF */
      DELETE tt-aa-edi-system.
    END. /* REPEAT */
    INPUT CLOSE.
    OS-DELETE VALUE(FILE-INFO:FULL-PATHNAME).
  END. /* IF */


  /*-- services goed zetten  --*/
  FOR EACH aa-edi-srv WHERE
           aa-edi-srv.ind_active
           NO-LOCK :
    FIND aa-edi-scheduler-service WHERE
         aa-edi-scheduler-service.schedulerid_code = "SCHEDULER"
         NO-LOCK NO-ERROR.
    IF NOT AVAILABLE aa-edi-scheduler-service
    THEN DO:
      CREATE aa-edi-scheduler-service.
      ASSIGN aa-edi-scheduler-service.SCHEDULERID_CODE = "scheduler"
             aa-edi-scheduler-service.service_code = aa-edi-srv.service_code
             .
    END. /* IF */
  END.


  /*--- "Scheduler" aanmaken om de bestaande tabellen aa-edi-schedule te vullen ----*/
  FIND aa-edi-scheduler WHERE
       aa-edi-scheduler.schedulerid_code = "SCHEDULER"
       NO-LOCK NO-ERROR.
  IF NOT AVAILABLE aa-edi-scheduler
  THEN DO:
    CREATE aa-edi-scheduler.
    ASSIGN aa-edi-scheduler.schedulerid_code = "SCHEDULER"
           aa-edi-scheduler.des = "Scheduler"
           .
  END. /* IF */

  /*- de onderliggende tabellen bestonden al, zorgen dat ze 
      een goede primaire key hebben, met "SCHEDULER" er boven --*/
  FOR EACH aa-edi-schedule WHERE 
           aa-edi-schedule.schedulerid_code = ? OR aa-edi-schedule.schedulerid_code = ""
           EXCLUSIVE-LOCK :
    aa-edi-schedule.schedulerid_code = "SCHEDULER".
    aa-edi-schedule.edi_set = "".
  END.
  FOR EACH aa-edi-schedule-comm WHERE
           aa-edi-schedule-comm.schedulerid_code = ? OR aa-edi-schedule-comm.schedulerid_code = ""
           EXCLUSIVE-LOCK :
    aa-edi-schedule-comm.schedulerid_code = "SCHEDULER".
  END.



  /*-- scheduled tasks 4Gl procedures goed zetten --*/
  FOR EACH b-aa-edi-schedule WHERE 
           LENGTH(b-aa-edi-schedule.task_4gl) > 0
           EXCLUSIVE-LOCK:

   CASE b-aa-edi-schedule.schedule_code :
     WHEN 'CDS5'
     THEN ASSIGN b-aa-edi-schedule.task_4gl = 'PROCEDURE-6'.
     WHEN 'CDS6'
     THEN ASSIGN b-aa-edi-schedule.task_4gl = 'PROCEDURE-7'.
     WHEN 'CDS7'
     THEN ASSIGN b-aa-edi-schedule.task_4gl = 'PROCEDURE-5'.
     WHEN 'CDS8'
     THEN ASSIGN b-aa-edi-schedule.task_4gl = 'PROCEDURE-2'.
     WHEN 'COMMS'
     THEN ASSIGN b-aa-edi-schedule.task_4gl = 'PROCEDURE-15'.
  
     OTHERWISE ASSIGN b-aa-edi-schedule.task_4gl = ''.
   END CASE.
  END. /* FOR EACH b-aa-edi-schedule */
END. /* DO TRANSACTION */

