



/*-- companycode is nu verplicht voor aa-edi-schedule
     omdat er company afhankelijke gegevens gebruikt worden (email)
     hier controleren en zonodig instellen ---*/  
     
DEFINE BUFFER b-aa-edi-srv-par FOR aa-edi-srv-par.

/*-- de oude smtp server --*/
FIND b-aa-edi-srv-par WHERE TRUE 
 AND b-aa-edi-srv-par.service_code = 'EMAIL'
 AND b-aa-edi-srv-par.par_name     = 'smtpserver'
     EXCLUSIVE-LOCK NO-ERROR.
     
      
FOR EACH aa-edi-schedule EXCLUSIVE-LOCK :

    FIND aa-edi-system WHERE 
         aa-edi-system.system_type = "4GL_PROCEDURE"
    AND  aa-edi-system.system_code = aa-edi-schedule.task_4gl
         NO-LOCK NO-ERROR.

    FIND sp-company WHERE
         sp-company.companycode = aa-edi-schedule.runcomp 
         NO-LOCK NO-ERROR.
    IF NOT AVAILABLE sp-company
    THEN DO:
      FIND FIRST sp-company.
      ASSIGN aa-edi-schedule.runcomp = sp-company.companycode.

      FIND sp-company WHERE
           sp-company.companycode = aa-edi-schedule.runcomp 
           NO-LOCK NO-ERROR.

      MESSAGE "Schedule:" SKIP
              aa-edi-schedule.schedulerid_code + "/" + aa-edi-schedule.schedule_code SKIP
              "has an invalid companycode, is now set to:" sp-company.companycode SKIP
              "Please verify after conversion."
              VIEW-AS ALERT-BOX.

    END. /* IF */

    /*-- communicatie? 
         SMTP server overnemen --*/
    IF AVAILABLE aa-edi-system 
       AND INDEX(aa-edi-system.edit_parameter_proc, "Communicate") > 0
    THEN DO:

      IF AVAILABLE b-aa-edi-srv-par
      THEN DO:
        IF sp-company.ind_blat <> TRUE
        THEN DO:
          FIND sp-company WHERE
               sp-company.companycode = aa-edi-schedule.runcomp 
               EXCLUSIVE-LOCK NO-ERROR.
          ASSIGN sp-company.ind_blat    = TRUE
                 sp-company.blat_server = b-aa-edi-srv-par.par_value.
        END. /* IF */
        ELSE DO:  /* SMTP al ingevuld, dus niet converteren */
          MESSAGE  "SMTP server setting:"
                   "For company " sp-company.companycode " " sp-company.blat_server SKIP
                   "Old setting was " b-aa-edi-srv-par.par_value
                   VIEW-AS ALERT-BOX WARNING.
        END. /* ELSE */
      END. /* IF */
    END. /* IF */
END.

IF AVAILABLE b-aa-edi-srv-par
THEN DO:
  DELETE b-aa-edi-srv-par.
END. /* IF */

/*-- default supress warnings aan --*/
DEFINE BUFFER b-aa-edi-control FOR aa-edi-control.
FIND b-aa-edi-control WHERE TRUE 
 AND b-aa-edi-control.controlkode = 'SuppressWarnings'
 EXCLUSIVE-LOCK NO-ERROR.
 IF NOT AVAILABLE b-aa-edi-control
 THEN CREATE b-aa-edi-control.
 ASSIGN 
	b-aa-edi-control.controlkode = 'SuppressWarnings'
	b-aa-edi-control.lijst = 'yes'
	b-aa-edi-control.lijst-2 = ''
	b-aa-edi-control.uitleg = ''
	.

