

/* -------------------------------------------------------------------------------- */
  FUNCTION spSetEntry
    RETURNS CHARACTER
      ( INPUT pcLabel     AS CHARACTER, 
        INPUT pcValue     AS CHARACTER,
        INPUT pcValueList AS CHARACTER, 
        INPUT pcSep1      AS CHARACTER, 
        INPUT pcSep2      AS CHARACTER ) :

    /* {system/include/sp-set-entry.i}    rdb 21-8-2006 include gekopieerd  */
/*------------------------------------------------------------------------------
  Purpose:  Updates pcValuelist  met de waarde (pcValue) van een (nieuwe) entry
  Voorbeeld pcvaluelist : A=kees,C=klaas,D=piet
            pcLabel = C
            pcValue = Klazien 
            pcSep1  = ","
            pcSep2  = "="
            
            Return value wordt : A=kees,C=klazien,D=piet
------------------------------------------------------------------------------*/
  DEFINE VARIABLE cOldList AS CHARACTER NO-UNDO.
  DEFINE VARIABLE cNewList AS CHARACTER NO-UNDO.
  DEFINE VARIABLE iTel     AS INTEGER   NO-UNDO.
  DEFINE VARIABLE lFound   AS LOGICAL   NO-UNDO.
  
  ASSIGN cOldList    = pcValueList
         pcVAlueList = REPLACE(pcVAlueList,pcSep2,pcSep1)
         .
  /*--- rebuild pcValueList and insert new number ---*/
  DO iTel = 1 TO NUM-ENTRIES(pcValueList,pcSep1) BY 2:
     IF ENTRY(iTel, pcValueList,pcSep1)  = pcLabel
     THEN DO:
       ASSIGN cNewList = cNewList 
                       + (IF cNewList = "" THEN "" ELSE pcSep1)
                       + pcLabel
                       + pcSep2
                       + pcValue
              lFound   = True         
                       .
     END. /*    IF ENTRY(iTel, pcValueList, ",")  = pcLabel */
  
     ELSE DO:
       ASSIGN cNewList = cNewList 
                       + (IF cNewList = "" THEN "" ELSE pcSep1)
                       + ENTRY(iTel, pcValueList,pcSep1)
                       + pcSep2
                       + ENTRY(iTel + 1, pcValueList, pcSep1)

                       .
     END. /* ELSE */
  END. /* DO */       
  
  /*--- if not found then add ---*/
  IF NOT lFound 
  THEN ASSIGN cNewList = cOldList 
                       + (IF cOldList = "" THEN "" ELSE pcSep1)
                       + pcLabel
                       + pcSep2
                       + pcValue
                       .
 
  RETURN cNewList.   /* Function return value. */


  END FUNCTION.

    FUNCTION spGetEntry
      RETURNS CHARACTER
        ( INPUT pcLabel     AS CHARACTER, 
          INPUT pcValueList AS CHARACTER,
          INPUT pcSep1      AS CHARACTER, 
          INPUT pcSep2      AS CHARACTER ) :

      /* {system/include/sp-get-entry.i}  rdb 21-8-2006 include gekopieerd */
/*------------------------------------------------------------------------------
  Purpose:  Geeft de waarde (pcValue) van een entry uit pcValuelist 
  Voorbeeld pcLabel = C
            pcvaluelist : A=kees,C=klaas,D=piet
            pcSep1  = ","
            pcSep2  = "="
            
            Return value wordt : klaas
 ------------------------------------------------------------------------------ */
    
    DEF VAR cValue AS CHAR NO-UNDO.
    DEF VAR iTel   AS INT  NO-UNDO.
    DEF VAR iPos   AS INT  NO-UNDO.

    ASSIGN pcValuelist = REPLACE(pcValuelist,pcSep2,pcSep1).
      
    iPos = LOOKUP (pcLabel,pcValueList,pcSep1).

    IF iPos MODULO 2 <> 0 /* dan is het een label , anders een waarde */  
    THEN DO:
     cValue = ENTRY(iPos + 1, pcValueList,pcSep1).
    END. /* IF */
    ELSE DO:
      SEARCHBLOCK:
      DO iTel = 1 TO NUM-ENTRIES(pcValueList,pcSep1) BY 2:
         IF ENTRY(iTel, pcValueList,pcSep1)  = pcLabel
         THEN DO: 
           cValue = ENTRY(iTel + 1, pcValueList,pcSep1).
           LEAVE SEARCHBLOCK. 
         END.
      END. /* DO */       
    END. /* ELSE */ 

 RETURN cValue.   /* Function return value. */

    END FUNCTION.
/* -------------------------------------------------------------------------------- */

DEF VAR cValue AS CHAR NO-UNDO.

DEFINE BUFFER b-schedule FOR aa-edi-schedule.

/*- default gedrag mbt "missed" goed zetten -*/
DO TRANSACTION :
    FOR EACH b-schedule 
             EXCLUSIVE-LOCK :
        cValue = spGetEntry("missed", b-schedule.sched_options, ",", "=").
        IF cValue = "" OR cValue = ? 
        THEN DO:
          b-schedule.sched_options = spSetEntry("missed", "yes", b-schedule.sched_options, ",", "=").
          b-schedule.sched_options = spSetEntry("missedwindow", "0", b-schedule.sched_options, ",", "=").
        END.
    END.
END.

