{system/conversion/conversion_progress.i}

/* voorbeeld conversie programma */

/*
- zet nooit een include in je conversie programma's , deze staan niet in de uitleverset 
- als de database triggers niet persee af hoeven te gaan , disable ze dan 
- gebruik een form om info + tellers te tonen                  
- gebruik de FIELDS optie als je maar weinig velden hoeft te updaten.

- OF gebruik het TRANSACTION keyword als je bij de FOR EACH een EXCLUSIVE-LOCK opgeeft  
  zie onderstaand voorbeeld A

- OF gebruik een buffer voor de tabel als je de FOR EACH met NO-LOCK leest  
  zie onderstaand voorbeeld B


Gr,
Hans

*/

DEF VAR cProgram                      AS CHAR NO-UNDO.
DEF VAR cAction                       AS CHAR NO-UNDO.
DEF VAR cTable                        AS CHAR NO-UNDO.
DEF VAR iTotal                        AS INT  NO-UNDO.
DEF VAR iDone                         AS INT  NO-UNDO.
DEF VAR iModulo                       AS INT  NO-UNDO.

cProgram =  THIS-PROCEDURE:FILE-NAME.
cAction  = "Ombouwen reserve velden naar dedicated velden, conversie Name veld naar Surname, codeveld voor gender ipv M/F".
iModulo =  100.  /* om de 100 records info tonen */


DISABLE TRIGGERS FOR LOAD OF aa-address_contact.                                        


FORM "Program  :" AT 1 cProgram   NO-LABEL  FORMAT "x(50)"    AT 12  SKIP
     "Action   :" AT 1 cAction    NO-LABEL  FORMAT "x(50)"    AT 12  SKIP
     "Table    :" AT 1 cTable     NO-LABEL  FORMAT "x(50)"    AT 12  SKIP
     "Total    :" AT 1 iTotal     NO-LABEL  FORMAT "9999999"  AT 12  SKIP
     "Done     :" AT 1 iDone      NO-LABEL  FORMAT "9999999"  AT 12  SKIP   
     WITH FRAME a.



DEFINE BUFFER b-aa-address_contact FOR aa-address_contact.

cTable = "aa-address_contact".
RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

/* Voorbeeld A */

iDone = 0.

FIND sp-control WHERE
     sp-control.controlkode = "10.03-after02"
     NO-LOCK NO-ERROR.

IF NOT AVAIL sp-control
THEN DO:
  FOR EACH aa-address_contact
           EXCLUSIVE-LOCK TRANSACTION:
   
   /* waardes reserve velden overzetten naar nieuwe velden */
   ASSIGN aa-address_contact.firstname = aa-address_contact.extra_1
          aa-address_contact.surname   = aa-address_contact.extra_2
          .
  
   /* reserve velden netjes opschonen */
   ASSIGN aa-address_contact.extra_1 = ""
          aa-address_contact.extra_2 = "".
  
   /* Indien men al first en surname ingegeven heeft niet converteren */
   IF aa-address_contact.firstname = "" AND
      aa-address_contact.surname   = "" 
   THEN aa-address_contact.surname = aa-address_contact.name.
   
   /* M/F is nu een codeveld geworden ipv een logical */
   IF aa-address_contact.sex = TRUE
   THEN aa-address_contact.gendercode = "M".
   ELSE aa-address_contact.gendercode = "F".
   
   iDone = iDone  + 1.
   IF iDone MODULO iModulo = 0 THEN RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

  END.

  DO TRANSACTION:
    CREATE sp-control.
    ASSIGN sp-control.controlkode = "10.03-after02".
  END.

END.
RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).







