
/*------------------------------------------------------------------------
    File        : aa-1703-after-04-reports-updates.p
    Purpose     : 

    Syntax      :

    Description : - Aanpassen standaard report definities Ultimo lijsten ivm. performance updates
                  - Ontbrekende prepProcedure voor Payments per Creditor corrigeren ivm. periode input check.
    
    Author(s)   : Hans/Marc (aanpassingen)
    Created     : Thu Apr 26 10:06:20 CEST 2012
    Notes       : 
                  - zet nooit een include in je conversie programma's, deze staan niet in de uitleverset
                    (met uitzondering van system/conversion.conversion_progress.i) 
                  - als de database triggers niet persee af hoeven te gaan , disable ze dan

                  - gebruik de procedure 'DisplayProgress' om info/voortgang en tellers te tonen
                  - gebruik de FIELDS optie als je maar weinig velden hoeft te updaten.

                  - OF gebruik het TRANSACTION keyword als je bij de FOR EACH een EXCLUSIVE-LOCK opgeeft  
                    zie onderstaand voorbeeld A

                  - OF gebruik een buffer voor de tabel als je de FOR EACH met NO-LOCK leest  
                    zie onderstaand voorbeeld B
     
  ----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

/* Deze standaard include toevoegen aan conversie programmatuur,
   o.a de DisplayProgress procedure en input paramatere naar de 
   aanroepende procedure worden hier in gedefineerd.
   Hierdoor wordt de aansluiting naar de update procedure gemaakt.
      
   Opmerking: Deze include wordt opgenomen in de System/comversion 
              directory welke als ongecompileerd bestand. 
              Het is de enige include die opgenomen mag worden in
              de conversie programmatuur.
*/
{System/conversion/conversion_progress.i}


/* ********************  Preprocessor Definitions  ******************** */


/* ***************************  Main Block  *************************** */
DEF VAR cProgram AS CHAR NO-UNDO.
DEF VAR cAction  AS CHAR NO-UNDO.
DEF VAR cTable   AS CHAR NO-UNDO.
DEF VAR iTotal   AS INT  NO-UNDO.
DEF VAR iDone    AS INT  NO-UNDO.
DEF VAR iModulo  AS INT  NO-UNDO.

/* --------------------------------------------------------------
  Disable triggers op de tabel indien dit mogelijk of
  onderzoek de effecten als de triggers aan moeten 
  blijven staan 
   -------------------------------------------------------------- */
DISABLE TRIGGERS FOR LOAD OF aa-fin_report.                                        
DEFINE BUFFER b-aa-fin_report FOR aa-fin_report.

FUNCTION spSetEntry RETURNS CHARACTER
  ( INPUT pcLabel     AS CHARACTER,
  INPUT pcValue     AS CHARACTER,
  INPUT pcValueList AS CHARACTER,
  INPUT pcSep1      AS CHARACTER,
  INPUT pcSep2      AS CHARACTER ) :

  DEFINE VARIABLE cOldList AS CHARACTER NO-UNDO.
  DEFINE VARIABLE cNewList AS CHARACTER NO-UNDO.
  DEFINE VARIABLE iTel     AS INTEGER   NO-UNDO.
  DEFINE VARIABLE lFound   AS LOGICAL   NO-UNDO.

  /*-- om te voorkomen dat de gehele string wordt gewist --*/
  IF pcValue EQ ?
    THEN pcValue = ''.

  ASSIGN 
    cOldList    = pcValueList
    pcVAlueList = REPLACE(pcVAlueList,pcSep2,pcSep1)
    .
  /*--- rebuild pcValueList and insert new number ---*/
  DO iTel = 1 TO NUM-ENTRIES(pcValueList,pcSep1) BY 2:
    IF ENTRY(iTel, pcValueList,pcSep1)  = pcLabel
      THEN 
    DO:
      ASSIGN 
        cNewList = cNewList
                       + (IF cNewList = "" THEN "" ELSE pcSep1)
                       + pcLabel
                       + pcSep2
                       + pcValue
        lFound   = TRUE
        .
    END. /*    IF ENTRY(iTel, pcValueList, ",")  = pcLabel */

    ELSE 
    DO:
      ASSIGN 
        cNewList = cNewList
                       + (IF cNewList = "" THEN "" ELSE pcSep1)
                       + ENTRY(iTel, pcValueList,pcSep1)
                       + pcSep2
                       + ENTRY(iTel + 1, pcValueList, pcSep1)

        .
    END. /* ELSE */
  END. /* DO */

  /*--- if not found then add ---*/
  IF NOT lFound
    THEN ASSIGN cNewList = cOldList
                       + (IF cOldList = "" THEN "" ELSE pcSep1)
                       + pcLabel
                       + pcSep2
                       + pcValue
      .

  RETURN cNewList.   /* Function return value. */

END FUNCTION.

FUNCTION spGetEntry RETURNS CHARACTER
  ( pcLabel      AS CHAR,
  pcValueList  AS CHAR,
  pcSep1       AS CHAR,
  pcSep2       AS CHAR ) :

  DEF VAR cValue AS CHAR NO-UNDO.
  DEF VAR iTel   AS INT  NO-UNDO.
  DEF VAR iPos   AS INT  NO-UNDO.

  ASSIGN 
    pcValuelist = REPLACE(pcValuelist,pcSep2,pcSep1).
      
  iPos = LOOKUP (pcLabel,pcValueList,pcSep1).

  IF iPos MODULO 2 <> 0 /* dan is het een label , anders een waarde */  
    THEN 
  DO:
    cValue = ENTRY(iPos + 1, pcValueList,pcSep1).
  END. /* IF */
  ELSE 
  DO:
    SEARCHBLOCK:
    DO iTel = 1 TO NUM-ENTRIES(pcValueList,pcSep1) BY 2:
      IF ENTRY(iTel, pcValueList,pcSep1)  = pcLabel
        THEN 
      DO: 
        cValue = ENTRY(iTel + 1, pcValueList,pcSep1).
        LEAVE SEARCHBLOCK. 
      END.
    END. /* DO */       
  END. /* ELSE */ 

  RETURN cValue. 

END FUNCTION.

ASSIGN 
  cProgram = THIS-PROCEDURE:FILE-NAME
  iModulo  = 100  /* om de 100 records info tonen */
  cTable   = "aa-fin_report"
  cAction  = "Update standard raport definities"
  iTotal   = 0.

RUN DisplayProgress (cProgram, cAction, cTable    , iTotal     , iDone).

FOR EACH sp-company NO-LOCK:

  FOR EACH b-aa-fin_report WHERE b-aa-fin_report.companycode = sp-company.companycode 
    AND b-aa-fin_report.applicatiekode = 'AA'
    AND b-aa-fin_report.modelkode = 'XFIN_PAYABLE'
    AND b-aa-fin_report.filename = 'AA\report\aa-fin_payable-open-ultimo.rpt'
    AND b-aa-fin_report.report_seqnr = 1 EXCLUSIVE-LOCK TRANSACTION:
          
    b-aa-fin_report.ExportQuery = 'PrepProcedure=aa/p-aa-fin_payable-ultimo-custom.p' + CHR(10) + 
      'ExportProcedure=aa/p-aa-fin_payable-ultimo-export-custom.p' + CHR(10) +
      'ForceFields=ind_paid,acc_period-from,acc_year-from' + CHR(10) +
      'ForceValues=|00|0000'.  
  
    iDone = iDone  + 1.
    IF iDone MODULO iModulo = 0  THEN RUN DisplayProgress (cProgram, cAction, cTable    , iTotal     , iDone).
 
  END.      

  RUN DisplayProgress (cProgram, cAction, cTable    , iTotal     , iDone).

  FOR EACH b-aa-fin_report WHERE b-aa-fin_report.companycode = sp-company.companycode 
    AND b-aa-fin_report.applicatiekode = 'AA'
    AND b-aa-fin_report.modelkode = 'XFIN_PAYABLE'
    AND b-aa-fin_report.filename = 'AA\report\aa-fin_payable-open-ultimo-totals.rpt'
    AND b-aa-fin_report.report_seqnr = 1 EXCLUSIVE-LOCK TRANSACTION:

    b-aa-fin_report.ExportQuery = 'PrepProcedure=aa/p-aa-fin_payable-ultimo-custom.p' + CHR(10) + 
      'ExportProcedure=aa/p-aa-fin_payable-ultimo-export-custom.p' + CHR(10) +
      'ForceFields=ind_paid,acc_period-from,acc_year-from' + CHR(10) +
      'ForceValues=|00|0000'.
  
    iDone = iDone  + 1.
    IF iDone MODULO iModulo = 0  THEN RUN DisplayProgress (cProgram, cAction, cTable    , iTotal     , iDone).          
  END.          

  RUN DisplayProgress (cProgram, cAction, cTable    , iTotal     , iDone).

  FOR EACH b-aa-fin_report WHERE b-aa-fin_report.companycode = sp-company.companycode 
    AND b-aa-fin_report.applicatiekode = 'AA'
    AND b-aa-fin_report.modelkode = 'XFIN_RECEIVABLE'
    AND b-aa-fin_report.filename = 'AA\report\aa-fin_receivable-open-ultimo.rpt'
    AND b-aa-fin_report.report_seqnr = 1 EXCLUSIVE-LOCK TRANSACTION:

    b-aa-fin_report.ExportQuery = 'PrepProcedure=aa/p-aa-fin_receivable-ultimo-custom.p' + CHR(10) + 
      'ExportProcedure=aa/p-aa-fin_receivable-ultimo-export-custom.p' + CHR(10) +
      'ForceFields=ind_paid,acc_period-from,acc_year-from' + CHR(10) +
      'ForceValues=|00|0000'.
  
    iDone = iDone  + 1.
    IF iDone MODULO iModulo = 0  THEN RUN DisplayProgress (cProgram, cAction, cTable    , iTotal     , iDone).          
  END. 

  RUN DisplayProgress (cProgram, cAction, cTable    , iTotal     , iDone).

  FOR EACH b-aa-fin_report WHERE b-aa-fin_report.companycode = sp-company.companycode 
    AND b-aa-fin_report.applicatiekode = 'AA'
    AND b-aa-fin_report.modelkode = 'XFIN_RECEIVABLE'
    AND b-aa-fin_report.filename = 'AA\report\aa-fin_receivable-open-ultimo-totals.rpt'
    AND b-aa-fin_report.report_seqnr = 1 EXCLUSIVE-LOCK TRANSACTION:

    b-aa-fin_report.ExportQuery = 'PrepProcedure=aa/p-aa-fin_receivable-ultimo-custom.p' + CHR(10) + 
      'ExportProcedure=aa/p-aa-fin_receivable-ultimo-export-custom.p' + CHR(10) +
      'ForceFields=ind_paid,acc_period-from,acc_year-from' + CHR(10) +
      'ForceValues=|00|0000'.
  
    iDone = iDone  + 1.
    IF iDone MODULO iModulo = 0  THEN RUN DisplayProgress (cProgram, cAction, cTable    , iTotal     , iDone).          
  END.             

  RUN DisplayProgress (cProgram, cAction, cTable    , iTotal     , iDone).

  FOR EACH b-aa-fin_report WHERE b-aa-fin_report.companycode = sp-company.companycode 
    AND b-aa-fin_report.applicatiekode = 'AA'
    AND b-aa-fin_report.modelkode = 'XFIN_RECEIVABLE'
    AND b-aa-fin_report.filename = 'AA\report\aa-fin_payment_creditors.rpt'
    AND b-aa-fin_report.report_seqnr = 1 EXCLUSIVE-LOCK TRANSACTION:

    IF spGetEntry("PrepProcedure", b-aa-fin_report.ExportQuery, CHR(10), "=") = "" THEN
      b-aa-fin_report.ExportQuery = spSetEntry("PrepProcedure", "aa/p-aa-fin-payments-creditor.p", b-aa-fin_report.ExportQuery, CHR(10), "=").
  
    iDone = iDone  + 1.
    IF iDone MODULO iModulo = 0  THEN RUN DisplayProgress (cProgram, cAction, cTable    , iTotal     , iDone).          
  END.   

  RUN DisplayProgress (cProgram, cAction, cTable    , iDone     , iDone).

END.