
DEF VAR cProgram      AS CHARACTER NO-UNDO.
DEF VAR cAction       AS CHARACTER NO-UNDO.
DEF VAR cTable        AS CHARACTER NO-UNDO.
DEF VAR iTotal        AS INTEGER   NO-UNDO.
DEF VAR iDone         AS INTEGER   NO-UNDO.
DEF VAR iPageNr       AS INTEGER   NO-UNDO.
DEF VAR iCurrentValue AS INTEGER   NO-UNDO.
DEF VAR iTmp          AS INTEGER   NO-UNDO.

{System/conversion/conversion_progress.i}


DEFINE BUFFER b-aa-rest_setting        FOR aa-rest_setting.
DEFINE BUFFER b-aa-rest_resource       FOR aa-rest_resource.
DEFINE BUFFER b-aa-rest_resource_field FOR aa-rest_resource_field.
DEFINE BUFFER b-sp-control             FOR sp-control.



ASSIGN cProgram = THIS-PROCEDURE:FILE-NAME
       cAction  = "Conversion b-aa-rest"
       iTotal   = 0
       iDone    = 0
       cTable   = "b-aa-rest_resource".


RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

DO TRANSACTION ON ERROR  UNDO, LEAVE
               ON ENDKEY UNDO, LEAVE:

  /* vullen connection_profile (nieuw in primary index) */
  FOR EACH b-aa-rest_setting EXCLUSIVE-LOCK WHERE b-aa-rest_setting.connection_profile <> "" :

    FOR EACH b-aa-rest_resource EXCLUSIVE WHERE b-aa-rest_resource.connection_profile = "" :

      b-aa-rest_resource.connection_profile = b-aa-rest_setting.connection_profile.
      b-aa-rest_resource.rest_resource_class = replace(b-aa-rest_resource.rest_resource_class, '.server.', subst('.&1.', b-aa-rest_resource.connection_profile)).

      FOR EACH b-aa-rest_resource_field  EXCLUSIVE WHERE
               b-aa-rest_resource_field.resource_seqnr = b-aa-rest_resource.resource_seqnr :
        b-aa-rest_resource_field.connection_profile = b-aa-rest_setting.connection_profile.
      END.


      /* client classes verhuist naar DP */
      IF b-aa-rest_resource.rest_resource_class = "AA.cls.Rest.client.aa-sf-account"
      THEN b-aa-rest_resource.rest_resource_class = "DP.cls.Rest.Salesforce.dp-sf-account".
      IF b-aa-rest_resource.rest_resource_class = "AA.cls.Rest.client.aa-sf-contact"
      THEN b-aa-rest_resource.rest_resource_class = "DP.cls.Rest.Salesforce.dp-sf-contact".


      RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

    END.


    /* nieuwe velden, voorheen in control codes */
    iTmp = INTEGER(AA.cls.aa-control:aaControl('rest-max-attempts', "Max.no. of failed authorisation attempts", "15")).
    IF iTmp > 0
    THEN DO:
      b-aa-rest_setting.max_auth_fails = iTmp.
      AA.cls.aa-control:aaControlDelete('rest-max-attempts').
    END.

    FIND b-sp-control WHERE
         b-sp-control.controlkode = 'RESTAPI-PROD-URL'
         EXCLUSIVE-LOCK NO-ERROR.
    IF AVAILABLE b-sp-control
    THEN DO:
      b-aa-rest_setting.rest_url_prod = b-sp-control.lijst.
      DELETE b-sp-control.
    END.

    FIND b-sp-control WHERE
         b-sp-control.controlkode = 'RESTAPI-TEST-URL'
         EXCLUSIVE-LOCK NO-ERROR.
    IF AVAILABLE b-sp-control
    THEN DO:
      b-aa-rest_setting.rest_url_test = b-sp-control.lijst.
      DELETE b-sp-control.
    END.

    FIND b-sp-control WHERE
         b-sp-control.controlkode = 'RESTAPI-EX-URL'
         EXCLUSIVE-LOCK NO-ERROR.
    IF AVAILABLE b-sp-control
    THEN DO:
      b-aa-rest_setting.examples_download_url = b-sp-control.lijst.
      DELETE b-sp-control.
    END.

    /* admin email stond eerst bij de replication parameters */
    FIND FIRST sp-client.
    b-aa-rest_setting.admin_email = sp-client.replication_mailto.

    RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

  END.
END.


RUN NieuweSysteemInfoVelden.

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

/* **********************  Internal Procedures  *********************** */

PROCEDURE NieuweSysteemInfoVelden :

  DISABLE TRIGGERS FOR LOAD OF aa-rest_resource_field.
  DEFINE BUFFER b-aa-rest_resource_field FOR aa-rest_resource_field.

  FIND b-aa-rest_resource_field WHERE
         b-aa-rest_resource_field.connection_profile = 'Salesforce'
    AND  b-aa-rest_resource_field.resource_seqnr = 54
    AND  b-aa-rest_resource_field.fieldname = 'httpmethodread'
    EXCLUSIVE-LOCK NO-ERROR.
  IF NOT AVAILABLE b-aa-rest_resource_field
  THEN DO:
    CREATE b-aa-rest_resource_field.
    ASSIGN
    b-aa-rest_resource_field.connection_profile = 'Salesforce'
    b-aa-rest_resource_field.resource_seqnr = 54
    b-aa-rest_resource_field.fieldname = 'httpmethodread'
    .
  END.
  ASSIGN
    b-aa-rest_resource_field.external_name = 'httpmethodread'
    b-aa-rest_resource_field.datatype = 'CHARACTER'
    b-aa-rest_resource_field.external_datatype = 'STRING'
    b-aa-rest_resource_field.fieldtype = 'D'
    b-aa-rest_resource_field.ind_hidden = NO
    b-aa-rest_resource_field.fieldformat = 'x(15)'
    b-aa-rest_resource_field.ind_rest_write_access = NO
    b-aa-rest_resource_field.ind_rest_read_access = YES
    b-aa-rest_resource_field.no_of_decimals = 0
    b-aa-rest_resource_field.order = 23
    b-aa-rest_resource_field.related_resource_seqnr = 0
    b-aa-rest_resource_field.ind_fieldmap_mandatory = NO
    .


  FIND b-aa-rest_resource_field WHERE
         b-aa-rest_resource_field.connection_profile = 'Salesforce'
    AND  b-aa-rest_resource_field.resource_seqnr = 54
    AND  b-aa-rest_resource_field.fieldname = 'httpmethoddelete'
    EXCLUSIVE-LOCK NO-ERROR.
  IF NOT AVAILABLE b-aa-rest_resource_field
  THEN DO:
    CREATE b-aa-rest_resource_field.
    ASSIGN
    b-aa-rest_resource_field.connection_profile = 'Salesforce'
    b-aa-rest_resource_field.resource_seqnr = 54
    b-aa-rest_resource_field.fieldname = 'httpmethoddelete'
    .
  END.
  ASSIGN
    b-aa-rest_resource_field.external_name = 'httpmethoddelete'
    b-aa-rest_resource_field.datatype = 'CHARACTER'
    b-aa-rest_resource_field.external_datatype = 'STRING'
    b-aa-rest_resource_field.fieldtype = 'D'
    b-aa-rest_resource_field.ind_hidden = NO
    b-aa-rest_resource_field.fieldformat = 'x(15)'
    b-aa-rest_resource_field.ind_rest_write_access = NO
    b-aa-rest_resource_field.ind_rest_read_access = YES
    b-aa-rest_resource_field.no_of_decimals = 0
    b-aa-rest_resource_field.order = 23
    b-aa-rest_resource_field.related_resource_seqnr = 0
    b-aa-rest_resource_field.ind_fieldmap_mandatory = NO
    .

  FIND b-aa-rest_resource_field WHERE
         b-aa-rest_resource_field.connection_profile = 'Salesforce'
    AND  b-aa-rest_resource_field.resource_seqnr = 54
    AND  b-aa-rest_resource_field.fieldname = 'httpmethodcreate'
    EXCLUSIVE-LOCK NO-ERROR.
  IF NOT AVAILABLE b-aa-rest_resource_field
  THEN DO:
    CREATE b-aa-rest_resource_field.
    ASSIGN
    b-aa-rest_resource_field.connection_profile = 'Salesforce'
    b-aa-rest_resource_field.resource_seqnr = 54
    b-aa-rest_resource_field.fieldname = 'httpmethodcreate'
    .
  END.
  ASSIGN
    b-aa-rest_resource_field.external_name = 'httpmethodcreate'
    b-aa-rest_resource_field.datatype = 'CHARACTER'
    b-aa-rest_resource_field.external_datatype = 'STRING'
    b-aa-rest_resource_field.fieldtype = 'D'
    b-aa-rest_resource_field.ind_hidden = NO
    b-aa-rest_resource_field.fieldformat = 'x(15)'
    b-aa-rest_resource_field.ind_rest_write_access = NO
    b-aa-rest_resource_field.ind_rest_read_access = YES
    b-aa-rest_resource_field.no_of_decimals = 0
    b-aa-rest_resource_field.order = 23
    b-aa-rest_resource_field.related_resource_seqnr = 0
    b-aa-rest_resource_field.ind_fieldmap_mandatory = NO
    .

  FIND b-aa-rest_resource_field WHERE
         b-aa-rest_resource_field.connection_profile = 'Salesforce'
    AND  b-aa-rest_resource_field.resource_seqnr = 54
    AND  b-aa-rest_resource_field.fieldname = 'connection_profile'
    EXCLUSIVE-LOCK NO-ERROR.
  IF NOT AVAILABLE b-aa-rest_resource_field
  THEN DO:
    CREATE b-aa-rest_resource_field.
    ASSIGN
    b-aa-rest_resource_field.connection_profile = 'Salesforce'
    b-aa-rest_resource_field.resource_seqnr = 54
    b-aa-rest_resource_field.fieldname = 'connection_profile'
    .
  END.
  ASSIGN
    b-aa-rest_resource_field.external_name = 'connection_profile'
    b-aa-rest_resource_field.datatype = 'CHARACTER'
    b-aa-rest_resource_field.external_datatype = 'STRING'
    b-aa-rest_resource_field.fieldtype = 'D'
    b-aa-rest_resource_field.ind_hidden = NO
    b-aa-rest_resource_field.fieldformat = 'x(35)'
    b-aa-rest_resource_field.ind_rest_write_access = NO
    b-aa-rest_resource_field.ind_rest_read_access = YES
    b-aa-rest_resource_field.no_of_decimals = 0
    b-aa-rest_resource_field.order = 23
    b-aa-rest_resource_field.related_resource_seqnr = 0
    b-aa-rest_resource_field.ind_fieldmap_mandatory = NO
    .

  FIND b-aa-rest_resource_field WHERE
         b-aa-rest_resource_field.connection_profile = 'Salesforce'
    AND  b-aa-rest_resource_field.resource_seqnr = 54
    AND  b-aa-rest_resource_field.fieldname = 'httpmethodupdate'
    EXCLUSIVE-LOCK NO-ERROR.
  IF NOT AVAILABLE b-aa-rest_resource_field
  THEN DO:
    CREATE b-aa-rest_resource_field.
    ASSIGN
    b-aa-rest_resource_field.connection_profile = 'Salesforce'
    b-aa-rest_resource_field.resource_seqnr = 54
    b-aa-rest_resource_field.fieldname = 'httpmethodupdate'
    .
  END.
  ASSIGN
    b-aa-rest_resource_field.external_name = 'httpmethodupdate'
    b-aa-rest_resource_field.datatype = 'CHARACTER'
    b-aa-rest_resource_field.external_datatype = 'STRING'
    b-aa-rest_resource_field.fieldtype = 'D'
    b-aa-rest_resource_field.ind_hidden = NO
    b-aa-rest_resource_field.fieldformat = 'x(15)'
    b-aa-rest_resource_field.ind_rest_write_access = NO
    b-aa-rest_resource_field.ind_rest_read_access = YES
    b-aa-rest_resource_field.no_of_decimals = 0
    b-aa-rest_resource_field.order = 23
    b-aa-rest_resource_field.related_resource_seqnr = 0
    b-aa-rest_resource_field.ind_fieldmap_mandatory = NO
    .

END PROCEDURE.
